<template>
  <v-layout
    row
    wrap>
    <v-flex xs12>
      <v-layout 
        row
        wrap>
        <v-flex xs12>
          <v-layout>
            <v-flex 
              text-xs-left
              xs6
              ma-2>
              <v-select
                v-model="source"
                :items="destinations.map(d => d.name)"
                label="Origem" 
                @change="updateRoutes()" />
            </v-flex>
            <v-flex 
              text-xs-left
              xs6
              ma-2>
              <v-select
                v-model="destination"
                :items="destinations.map(d => d.name)"
                label="Destino" 
                @change="updateRoutes()" />
            </v-flex>
          </v-layout>
        </v-flex>
      </v-layout>
    </v-flex>

    <v-flex 
      v-if="loading"
      xs12>
      <v-btn 
        :loading="loading" 
        flat 
      />
    </v-flex>

    <v-flex 
      v-if="planning.length > 0"
      xs12>
      <v-layout 
        row
        wrap>
        <v-flex xs12>
          <v-card xs12>
            <v-toolbar 
              dense 
              color="grey">
              Rota Planejada
            </v-toolbar>
            <v-card-text>
              <v-range-slider
                :tick-labels="stopsLabels"
                :value="[0, 1]"
                :max="stopsLabels.length - 1"
                always-dirty
                min="0"
                thumb-label
                thumb-size="64"
                ticks="always"
              >
                <template
                  slot="thumb-label"
                  slot-scope="props"
                >
                  <span class="text-xs-center">
                    C: {{ planning[props.value].collect.length }} pcts.<br>
                    E: {{ planning[props.value].deliver.length }} pcts.<br>
                    {{ planning[props.value].distance }} km
                  </span>
                </template>
              </v-range-slider>
            </v-card-text>
            <v-card-actions>
              <span class="title">Distância Total: {{ planning.map(p => p.distance).reduce((a, b) => a+b) }} Km</span>
            </v-card-actions>
          </v-card>
        </v-flex>
      </v-layout>
      <v-layout 
        row
        wrap
        mt-3>
        <v-flex xs4>
          <span class="title">Cidade</span>
        </v-flex>  
        <v-flex xs4>
          <span class="title">Coleta</span>
        </v-flex>  
        <v-flex xs4>
          <span class="title">Entrega</span>
        </v-flex>
      </v-layout>  
      <v-card xs12>
        <v-card-text>
          <v-layout 
            v-for="(stop, idx) in planning" 
            v-if="stop.collect.length > 0 || stop.deliver.length > 0"
            :key="idx"
            row
            wrap
            mt-3>
            <v-flex xs4>
              <span class="title">{{ stop.from }} </span>
            </v-flex>  
            <v-flex xs4>
              <span 
                v-for="(p, pi) in stop.collect.reduce((accum, item) => accum.concat(item.packages), [])" 
                :key="pi"
                class="body-1"
              >
                Cliente: {{ p.customer }} - {{ p.weight }}g<br>
              </span>
            </v-flex>  
            <v-flex 
              xs4 
              mb-1>
              <span 
                v-for="(p, pi) in stop.deliver.reduce((accum, item) => accum.concat(item.packages), [])" 
                :key="pi"
                class="body-1"
              >
                Cliente: {{ p.customer }} - {{ p.weight }}g<br>
              </span>
            </v-flex>
            &nbsp;<v-divider />
          </v-layout>
        </v-card-text>
      </v-card>
    </v-flex>
  </v-layout>
</template>
<script>
export default {
  asyncData (app) {
    return app.$axios.get('/locations')
      .then(response => {
        return response.data
      })
      .catch(error => {
        console.error(error)
        return []
      })
      .then(records => {
        var result = {
          destinations: records
        }
        return result
      })
  },

  data () {
    return {
      source: '',
      destination: '',
      planning: [],
      loading: false
    }
  },
  computed: {
    stopsLabels: function () {
      return this.planning.map(p => p.from)
    },
    stopsArray: function () {
      var array = new Array(this.planning.lenght)
      for(var x = 0; x < this.planning.length; x++) {
        array[x] = x
      }
      return array
    }
  },

  methods: {
    updateRoutes () {
      if (this.source === '' || this.destination === '')
        return

      var sourceRecord = this.destinations.filter(d => d.name === this.source)[0]
      var targetRecord = this.destinations.filter(d => d.name === this.destination)[0]

      this.$axios.get('/calculateRoute?from=' + sourceRecord._id.toString() + '&to=' + targetRecord._id.toString())
        .then(result => {
          this.loading = false
          this.planning = result.data
        })
    } 
  }
}
</script>
